unit fMain;

interface

uses
  Forms, StdCtrls, Controls, Classes, ExtCtrls, fWrapper;

type
  TfrmMain = class(TForm)
    Label6: TLabel;
    btnStart: TButton;
    btnStop: TButton;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure btnStartClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  protected
    FID: string;
    FActive: Boolean;
    FTestFunc: TTestFunc;
    function GetLabel(Index: Integer): TLabel;
    procedure SetActive(const Value: Boolean);
    procedure DO_TestFuncTimeChange(Sender: TObject; DateTime: TDateTime);
    procedure DO_TestFuncTextChange(Sender: TObject; Index: Integer; Text: string);
  public
    property Labels[Index: Integer]: TLabel read GetLabel;
    property Active: Boolean read FActive write SetActive;
    property TestFunc: TTestFunc read FTestFunc;
  end;

var
  frmMain: TfrmMain;

implementation

uses SysUtils;

{$R *.dfm}

{ TfrmMain }

function TfrmMain.GetLabel(Index: Integer): TLabel;
begin
  Result := FindComponent('Label' + IntToStr(Index)) as TLabel;
end;

procedure TfrmMain.SetActive(const Value: Boolean);
begin
  if Value <> FActive then
  begin
    FActive := Value;
    case FActive of
      True: FTestFunc.Connect;
      else  FTestFunc.Disconnect;
    end;
    btnStart.Enabled := not FActive;
    btnStop.Enabled := FActive;
    Timer1.Enabled := FActive;
  end;
end;

procedure TfrmMain.btnStartClick(Sender: TObject);
begin
  Active := TComponent(Sender).Tag = 999;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  Randomize;
  FID := Format('%5.5d', [Random($FFFF)]);
  Caption := 'Client ID = ' + FID;
  btnStart.Tag := 999;
  FTestFunc := TTestFunc.Create(Self);
  FTestFunc.OnTimeChange := DO_TestFuncTimeChange;
  FTestFunc.OnTextChange := DO_TestFuncTextChange;
end;

procedure TfrmMain.DO_TestFuncTimeChange(Sender: TObject;
  DateTime: TDateTime);
begin
  Label6.Caption := FormatDateTime('hh:nn:ss.zzz', DateTime);
end;

procedure TfrmMain.DO_TestFuncTextChange(Sender: TObject; Index: Integer; Text: string);
begin
  if Assigned(Labels[Index]) then Labels[Index].Caption := Text;
end;

procedure TfrmMain.Timer1Timer(Sender: TObject);
var
  S: string;
  R, Index: Integer;
begin
  R := Random(MaxInt);
  Index := R mod 6;
  S := Format('ID(%s): %10.10d', [FID, R]);
  FTestFunc.SetTexts(Index, S);
end;

end.
